#include "papu_waveunit.hh"
#include "papu_lengthunit.hh"

// lengthunit has 60 Hz ticker
// triangleunit has 240 Hz
// has no 120

class triangleunit : public waveunit, public lengthunit
{
    enum {triload, tricount} trimode;
    fBYTE linearcounter, triloadvalue;
    bool oldbit;
    bool jammed;
public:
    fBYTE trianglecounter;
public:
    triangleunit() : lengthunit(7), trimode(triload), linearcounter(0),
                     triloadvalue(0), oldbit(false), jammed(false), trianglecounter(0)
    {
    }
    
    void write(fBYTE ind, fBYTE value);

	
    inline bool silent() const
    {
        return jammed || lengthunit_silent();
    }
    
    BEGIN_WAVETICKER
        ++trianglecounter;	// Can do this even if silent
    END_WAVETICKER
    
	DEFINE_HZTICKER(240);

    void debug_silence()
    {
    	fprintf(stderr, "%sabled", chanenabled?"en":"dis");
    	fprintf(stderr, "; wlen=%u", wavelen);
    	lengthunit::debug_silence();
    }
};
